 ;spinaci hodiny pro ovladani UV lampy 0-99minut)
;vstup je multiplex displej
;1 vstup pro sepnuti rele,1 vystup pro sepnuti indikacni led a pieza
;vstup 2 tlacitek
;vyrobil Pavel eznek
;01/2010
;***************************************************************************
;definice registru a promenych
;***************************************************************************

;definice registru

freg		equ		0ch		;zacatek volne ram
mem_w		equ		0dh		;pamet w
mem_swr		equ		0eh		;pamet status
ctsek		equ		0fh		;citac sekund
ctmin		equ		10h		;citac mnut
ctdesmin	equ		11h		;citac desitek minut
reg_cas		equ		12h		;registr pro nastavovan hodnot casovace
mem_port	equ		13h		;pamet portuA
tmp		equ		14h		;universalni casovac
tmp1		equ		15h		;universalni casovac
pom_reg		equ		16h		;pomocny registr pro prevody jed,des,sto
JED		equ		17h		;registr jednotek pro displej
DES		equ		18h		;registr desitek pro displej
ochranny_cas	equ		19h		;ochrann casovac pred sepnutim uv lampy (15sek - jen v minut.odpoctu)


;definice promenych

#define		A1		PORTA,0	 	;vystup anody jednotek
#define		A10		PORTA,1		;vystup anody desitek
#define		led		PORTA,2		;vystup indikacni led
#define		plus		PORTA,3		;vstup tlacitka
#define		on		PORTA,4		;vstup tlacitka pro start

;PORTB je vystup pro sedmisegmentovku katody

#define		f_tl_plus	freg,0		;priznak seple klavesy plus
#define		f_tl_on		freg,1		;priznak seple klavesy on
#define		f_odpoctu	freg,2		;priznak pro odecitani casu
#define		f_konec		freg,3		;cas je na nule po odpoctu
#define		f_sekund	freg,4		;urcuje citani po sekundach (1) nebo minutach (0)
#define		f_ochrany	freg,5		;ochrany casovac bude zapnut

;***************************************************************************
		LIST   P=16F84
                #include d:\pic\P16F84.DEF
	__CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;***************************************************************************
		org	0x0000		;vektor resetu
		movlw	#0Ch    	;adresa volne ram
		movwf	FSR		;do fsr
		goto	reset
		
		org	0x0004		;vektor preruseni
		goto	inter
;***************************************************************************
;		tabulka znaku pro displ
;--------------------------------------------------------------------------- 
;pro zkusebni desticku
;znak            addwf   PCL,f           ;pricti w k pc a skoc
;               retlw   b'11000000'	;0
;		retlw	b'11111001'	;1
;		retlw	b'10100100'	;2
;		retlw	b'10110000'     ;3
;               retlw   b'10011001'	;4
;		retlw	b'10010010'	;5
;		retlw	b'10000010'	;6
;		retlw	b'11111000'    	;7
;               retlw   b'10000000'	;8
;		retlw	b'10010000'	;9

;hotov vrobek
znak            addwf   PCL,f           ;pricti w k pc a skoc
               	retlw   b'10000001'	;0
		retlw	b'10110111'	;1
		retlw	b'01000101'	;2
		retlw	b'00100101'     ;3
               	retlw   b'00110011'	;4
		retlw	b'00101001'	;5
		retlw	b'00001001'	;6
		retlw	b'10110101'    	;7
        	retlw   b'00000001'	;8
		retlw	b'00100001'	;9
;--------------------------------------------------------------------------
inter		movwf	mem_w		;uloz registry		
		movfw	STATUS
		movwf   mem_swr
		btfss	T0IF		;je preteceni tmr skoc
		goto	end_int
		bcf	T0IF		;smaz priznak
		clrf	TMR0
		incf	ctsek,f		;ctsek+1
		movlw	d'100'		;100
		subwf	ctsek,w		;f-W do w
		bnz	end_int		;w=0 skoc
		clrf	ctsek
	
;pri minutach bezi jeste 15 sek pred spustenim vystupu ochranny casovac
		btfss	f_ochrany	;je priznak ochraneho casovace?
		goto	inter_1
		bcf	led		;drz vyply vystup
		decf	ochranny_cas,f	;casovac-1
		bnz	inter_1
		bcf	f_ochrany	;smaz priznak
		bsf	f_odpoctu	;nastav priznak pro odpocitavani casu
				

	
inter_1		btfss	f_sekund	;neni priznak pro pocitani sekund skoc
		goto	minuty		
		btfsc	f_konec		;
		goto	minuty
		btfss	f_odpoctu	;je priznak odpoctu blikej sekundy
		goto	minuty
		bsf	led		;sepni vystup
		decf	reg_cas,f	;snizuj registr casu
		movf	reg_cas,w	;test na 0
		bnz	minuty
		bcf	led		;zhasni led
		bcf	f_odpoctu
		bsf	f_konec		;priznak pro dopocitani do nuly

		
minuty		btfsc	f_konec		;
		goto	desminut
		btfss	f_odpoctu	;je priznak odpoctu blikej sekundy
		goto	desminut
		bsf	led		;sepni vystup
		
		incf	ctmin,f		;minuty
		movlw	d'60'
		subwf	ctmin,w
		bnz	end_int
		clrf	ctmin
	
;		btfsc	f_konec		;
;		goto	desminut
;		btfss	f_odpoctu	;je priznak odpoctu blikej sekundy
;		goto	desminut
;		bcf	led		;sepni vystup
		decf	reg_cas,f	;snizuj registr casu
		movf	reg_cas,w	;test na 0
		bnz	desminut
		bcf	led		;zhasni led
		bcf	f_odpoctu
		bsf	f_konec		;priznak pro dopocitani do nuly
		

desminut	incf	ctdesmin,f	;hodiny
		movlw	d'60'
		subwf	ctdesmin,w
		bnz	end_int
		clrf	ctdesmin

end_int		bsf	T0IE		;povol preruseni
		movfw	mem_swr		;konec preruseni
		movwf	STATUS		;obnov registry
		movfw	mem_w
		retfie

;--------------------------------------------------------------------

reset		clrf	INDF		;vynuluj indf
		incf	FSR,f		;fsr+1
		btfss	FSR,6		;6bit=1 skoc
		goto	reset
		clrf	PORTA
		clrf	PORTB
		bsf	RP0		;banka1
		clrf	PORTB		;portB je vystupni
		movlw	b'11111000'	;RA0-2 jsou vystupy
		movwf	PORTA		;zbytek jsou vstupy
		movlw	b'0000100' 	;nastaveni option reg
		movwf	OPTION_REG
		bcf	RP0		;banka 0
		movlw	b'10100000'
		movwf	INTCON		;povolenipreruseni
		clrf	TMR0
		bcf	led		;zhasni vystup ledky
;test tla. ON pokud je stiskle budou odpocitavany sek jinak minuty
		btfsc	on		;test tlacitka
		goto	nastav_m	;nuluj priznak
		call	test_klaves
		bsf	f_sekund	;nastav priznak pro sek
		bcf	A1		;zapni displej
		movlw	b'00101001'	;indikuj S (pro sek)
		movwf	PORTB
		movlw	0xff
		movwf	tmp
		movwf	tmp1
		call	cekej		;cekej pro zobrazeni symbolu
		bsf	A1
		goto	start
		
;vynuluj priznak bude pocitat po minutach
nastav_m	bcf	f_sekund


start		btfsc	f_odpoctu	;neni priznak odpoctu skoc
		goto	odpocet

;test klavesnice
		btfsc	plus		;test tlacitka
		goto	nuluj_f_plus	;nuluj priznak
;		goto	test_on_tl
		btfsc	f_tl_plus		;
		goto	test_on_tl	;jdi na test druheho tlacitka
		bsf	f_tl_plus
		call	test_klaves
		incf	reg_cas,f	;pri stisku tlacitka zvysuj o 1
		movlw	d'100'		;maximalni hodnota 1,5min,1,5hod (90)
		subwf	reg_cas,w
		skpnz			;neni nula skoc
		clrf	reg_cas		;jinak nuluj registr


;zobrazuj obsah registru na displeji
test_on_tl	movf	reg_cas,w	;test na nulu
		bz	odpocet		;je registr v nule skoc (nesmi jit postit dalsi odpocet)
		btfsc	on		;test tlacitka
		goto	nuluj_f_on	;nuluj priznak
		btfsc	f_tl_on		;
		goto	odpocet
		bsf	f_tl_on
		bcf	f_konec
		call	test_klaves
;		bsf	f_odpoctu
		btfsc	f_ochrany	;test na vlozeni casove konstanty
		goto	odpocet
		bsf	f_ochrany
		movlw	14h		;20 sekund ochranneho casu
		movwf	ochranny_cas	;vloz do registru

;snizuje casovac
odpocet		call	prevod		;proved prevod pro displej
		call	zobraz		;zobraz hodnotu na displeji
		goto	start


;nuluj priznak klavesy
nuluj_f_on	bcf	f_tl_on
		goto	odpocet
nuluj_f_plus	bcf	f_tl_plus	
		goto	test_on_tl	;jdi na test druheho tlacitka
;-------------------------------------------------------------------------
;	test klavesnice portu B
;-------------------------------------------------------------------------
test_klaves	movfw	PORTA		;sejmi port
		andlw	b'00011000'	;zamaskuj nepotebne vstupy a vystupy		
		movwf	mem_port	;uloz do mem_port
		call	cek20m		;cekej
		movfw	PORTB		;znova sejmi port
		andlw	b'00011000'	;zamaskuj nepotrebny
		xorwf	mem_port,w	;test shody
		skpz	
		retlw	01h		;bylo ruseni
		retlw	00h		;00 hex nebylo ruseni
;-------------------------------------------------------------------------
;	cekaci smycky
;-------------------------------------------------------------------------
cek20m		movlw	19h		;konstanta do w 
		movwf	tmp1		;w do tmp1
		movlw	66h		;15mS
		movwf	tmp		;konstanta do tmp1
		goto	cekej		;jdi na cekej

cek_400u	movlw	04h		;konstanta do w 01
		movwf	tmp1		;w do tmp1
		movlw	0Ah		;15mS
		movwf	tmp		;konstanta do tmp1
		goto	cekej		;jdi na cekej

cekej		decfsz	tmp,f		;tmp-1 je li 0 skoc
		goto	cekej
		movfw	tmp1
		btfsc	Z
		retlw	00h
		decf	tmp1,f		;tmp-1 je li 0 skoc
		goto	cekej
;-------------------------------------------------------------------------
;prevede hex cislo na jednoty a desitky
;-------------------------------------------------------------------------
prevod		btfss	f_ochrany	;je priznak ochranneho casovace skoc
		goto	prevod_1
		movfw	ochranny_cas
		goto	$+2
prevod_1	movfw	reg_cas		;
		movwf	pom_reg
		clrf	DES
		clrf	JED
pre_10		movlw	d'10'
		subwf	pom_reg,w
		btfss	C
		goto	pre_1
		movwf	pom_reg
		incf	DES,f
		goto	pre_10
pre_1		movfw	pom_reg
		movwf	JED
		return
;-------------------------------------------------------------------------
;podprogram pro ovladani displej
;-------------------------------------------------------------------------
zobraz		bcf	A1		;zapni anodu pro jednotky
		movfw	JED		;vem jednotky
		call	znak		;prirad	hodnotu
		movwf	PORTB		;a nakopiruj ji do portuB
		call	cek_400u	;cekej 400uS		
		bsf	A1		;zhasni znak jednotek

		bcf	A10		;to same pro desitky
		movfw	DES
		call	znak
		movwf	PORTB
		call	cek_400u	;cekej 400uS
		bsf	A10
		return	
;-------------------------------------------------------------------------	



		end